      FUNCTION filter(i,x,y,n,z)
 
c...... Returns flux through i filter. The SED is y(x) with n data
c...... points. z is the redshift to be applied to the SED
c to be modified using number of points union of lambda(filter) & lambda(sed)

      IMPLICIT NONE
      INTEGER i,n,l,m,mxwf,np,ifilt,mxfil
      INTEGER mxtyp_bc,mxtyp_as,mxtyp_pg,mxvega,mxafil,mxlyf,mxred,
     &     mxwl_bc,mxwl_pg,mxwl_as,mxwl,mxage_bc,mxage_pg,mxage,mxrp
      REAL*8 filter,rlin,xlam,ff,x,y,z,r,trapz1,tt
      INCLUDE 'dimensionz.dec'
      DIMENSION xlam(mxwf),ff(mxwf),x(1),y(1)
      EXTERNAL rlin,trapz1
      COMMON/compose/ifilt,np(mxfil+mxafil)
      COMMON/rfilter/r(mxwf,mxfil+mxafil,2)

      filter=0.D0
      IF (i.gt.ifilt) THEN
         STOP 'Requested filter is out of range' 
      END IF
      l=0
      DO m=1,np(i)
         xlam(m)=r(m,i,1)
         ff(m)=r(m,i,2)*rlin(xlam(m)/(1.D0+z),x,y,n,l)
      END DO
      tt=trapz1(xlam,ff,np(i))
      filter=tt/(1.D0+z)
      RETURN
      END

c ----------------------------------------------------------------------
